package at.jku.students.graph;

import at.jku.ssw.Iterator;
import at.jku.ssw.graph.Edge;
import at.jku.ssw.graph.Edge.Kind;
import at.jku.ssw.graph.Graph;
import at.jku.ssw.graph.Vertex;
import at.jku.ssw.list.List;

public class Warshall {

	/**
	 * Calculates the adjacency matrix of Graph <code>g</code>. The matrix is
	 * stored as <code>long</code> array. The value at array index
	 * <code>i</code> is a bit vector where a <code>1</code> at bit index
	 * <code>j</code> denotes a (directed) edge from vertex at index
	 * <code>i</code> to <code>j</code>. The vertex index in the matrix is the
	 * index in the {@link Graph#vertices vertex list}.
	 * 
	 * @throws IllegalArgumentException
	 *             if the graph g contains more than <code>64</code> vertices
	 */
	public static long[] graphToMatrix(Graph g) {
		// TODO
		return null;
	}

	/**
	 * Calculates the transitive closure of the matrix <code>m</code>. The
	 * result is stored in-place, which means that the content of the input
	 * matrix is modified.
	 * 
	 * @throws IllegalArgumentException
	 *             if the matrix m contains more than <code>64</code> vertices
	 */
	public static void transitiveClosure(long[] m) {
		// TODO
	}

	/**
	 * Creates a {@link Graph} from matrix <code>m</code>. The
	 * <code>vertices</code> list contains the vertices of the graph in order of
	 * their index in the matrix.
	 * 
	 * @see #graphToMatrix
	 * 
	 * @throws IllegalArgumentException
	 *             if the graph g contains more than <code>64</code> vertices
	 */
	public static Graph matrixToGraph(List vertices, long[] m) {
		// TODO
		return null;
	}

	/**
	 * Returns <code>true</code> if bit <code>idx</code> is set in
	 * <code>bitVector</code>.
	 * 
	 * @throws IllegalArgumentException
	 *             if <code>idx > 63 || idx < 0</code>
	 */
	public static boolean isBitSet(long bitVector, int idx) {
		// TODO
		return false;
	}

	/**
	 * Set bit <code>idx</code> in <code>bitVector</code> to <code>true</code>
	 * and returns the new value for the vector.
	 * 
	 * @throws IllegalArgumentException
	 *             if <code>idx > 63 || idx < 0</code>
	 */
	public static long setBit(long bitVector, int idx) {
		// TODO
		return 0;
	}
}
